#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h> 
#include <unistd.h> 
#include <signal.h>
#include <strings.h>
#include <stdlib.h>

#define SERVER_PORT 7111
#define LEN_RECVBUFFER 1000
#define SERVER_IP_ADDRESS "127.0.0.1"

int main() {
    
    int sfd;
    struct  sockaddr_in saddr;
    pid_t childpid;
    size_t lenrecv, lensent, len, wlen;
    char recvbuffer[LEN_RECVBUFFER+1] = "";
    char sendbuffer[LEN_RECVBUFFER] = "";
    
    
    if ( 0 > ( sfd = socket(PF_INET,SOCK_STREAM,0) ) ) {
        perror("socket()-call");
        exit(1);
    }
    
    bzero((char *)&saddr,sizeof(saddr));
    saddr.sin_family = AF_INET;
    /*--- als IP adresse muss der String, zB 192.168.50.99
     in die 32-Bit Binaerreprsentation transformiert werden-*/
    saddr.sin_addr.s_addr = inet_addr(SERVER_IP_ADDRESS);
    saddr.sin_port = htons(SERVER_PORT);
    
    //Verbindung mit dem Server aufnehmen
    if ( -1 == (connect(sfd,
                        (struct sockaddr *)&saddr,
                        sizeof(saddr) )) ) {
        perror("connect()-call");
        exit(1);
    }
    
    //Aufteilung in Kind- und Vaterprozess
    if ( 0 > (childpid = fork()) ) {
        perror("fork()-call");
        exit(1);
    }
    
    /*--- Kindprozess aktivieren ---*/ 
    if ( !childpid ) {
        
        while ( 1 ) {
            
            //lesen
            if ( 0 > (lenrecv = 
                      read(sfd,recvbuffer,LEN_RECVBUFFER)) ) {
                perror("read()-call");
                exit(1);
            }
            
            //ausgeben
            if ( lenrecv > 0 ) {
                recvbuffer[lenrecv] = 0;
                printf("Empfange %s",recvbuffer);
                fflush(NULL);
            }
            
        }
        
    }
    
    //Vater
    while ( 1 ) {
        
        //Einlesen 
        scanf("%s",sendbuffer);
        len = strlen(sendbuffer);
        sendbuffer[len] = '\n';
        sendbuffer[len+1] = 0;
        len = len + 1;
        lensent = 0;
        
        //Senden
        while ( lensent < len ) {
            
            if ( 0 > (wlen = write(sfd,
                                   &(sendbuffer[lensent]),
                                   len - lensent)) ) {
                perror("write()-call");
                exit(1);
            }
            
            lensent = lensent + wlen;
        }
        
        //bei Eingabe von STOP wird der Client beendet
        if ( !strncmp(sendbuffer,"STOP",strlen("STOP")) ) {
            
            if(0 > kill(childpid, SIGTERM))
            {
                perror("Problem with kill()");
                exit(1);
            }
            
            if(0 > close(sfd))
            {
                perror("Problem with close()");
                exit(1);
            }
            
            exit(0);
        }
        
    }
    
}
